"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const exec_1 = require("@pnpm/exec");
const path = require("path");
const writeJsonFile = require("write-json-file");
const getPreviewDir_1 = require("./getPreviewDir");
const publishToDir_1 = require("./publishToDir");
function default_1(what, where) {
    return __awaiter(this, void 0, void 0, function* () {
        const pkgDir = path.resolve(what);
        where = path.resolve(where);
        const previewDir = yield getPreviewDir_1.default(where, path.basename(pkgDir));
        const distDir = path.join(previewDir, 'package');
        yield publishToDir_1.default(pkgDir, distDir);
        const pkg = require(path.join(distDir, 'package.json'));
        const wrapperPkg = {
            dependencies: pkg.peerDependencies || {},
        };
        // Would be better to install the package dirrectly from the tarball
        // in that case this hack would not be needed
        if (pkg.scripts) {
            delete pkg.scripts.prepare;
            delete pkg.scripts.prepublish;
        }
        yield writeJsonFile(path.join(distDir, 'package.json'), pkg);
        yield writeJsonFile(path.join(previewDir, 'package.json'), wrapperPkg);
        // This is where the peer dependencies are installed
        yield exec_1.default(['install', '--production'], {
            cwd: previewDir,
        });
        // Dependencies in the preview folder are installed during linking
        yield exec_1.default(['link', '--production', path.relative(where, distDir)], {
            cwd: where,
        });
    });
}
exports.default = default_1;
//# sourceMappingURL=index.js.map