"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const spawn = require("cross-spawn");
function default_1(opts) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            const proc = spawn('pnpm', opts.args, {
                cwd: opts.prefix,
                stdio: 'inherit',
            });
            proc.on('error', reject);
            proc.on('close', (code) => {
                if (code > 0)
                    return reject(new Error('Exit code ' + code));
                return resolve();
            });
        });
    });
}
exports.default = default_1;
//# sourceMappingURL=pnpmExec.js.map