"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fx = require("fs-extra");
const fs = require("mz/fs");
const path = require("path");
const rimraf = require("rimraf-then");
const unpackStream = require("unpack-stream");
const npmPack_1 = require("./npmPack");
function default_1(pkgDir, distDir) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield clearDistDir(distDir);
            yield fx.copy(path.join(pkgDir, 'shrinkwrap.yaml'), path.join(distDir, 'shrinkwrap.yaml'));
        }
        catch (err) {
            if (err.code !== 'ENOENT')
                throw err;
        }
        const tgzFilename = yield npmPack_1.default(pkgDir);
        const tarball = path.resolve(pkgDir, tgzFilename);
        yield fetchFromLocalTarball(tarball, distDir);
        yield fs.unlink(tarball);
    });
}
exports.default = default_1;
function fetchFromLocalTarball(tarball, dist) {
    return __awaiter(this, void 0, void 0, function* () {
        yield unpackStream.local(fs.createReadStream(tarball), dist, {
            generateIntegrity: false,
        });
    });
}
const filesToKeep = new Set(['node_modules', 'shrinkwrap.yaml']);
function clearDistDir(base) {
    return fs.readdir(base)
        .then((dirs) => {
        return Promise.all(dirs
            .filter((dir) => !filesToKeep.has(dir))
            .map((dir) => path.join(base, dir))
            .map(rimraf));
    });
}
//# sourceMappingURL=publishToDir.js.map